"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformRequireToImport = exports.compileSFCTemplate = void 0;
const component_compiler_utils_1 = require("@vue/component-compiler-utils");
const vueTemplateCompiler = __importStar(require("vue-template-compiler"));
const path_1 = __importDefault(require("path"));
function compileSFCTemplate(source, block, filename, { root, isProduction, vueTemplateOptions, devServer }, pluginContext) {
    const { tips, errors, code } = component_compiler_utils_1.compileTemplate({
        source,
        filename,
        compiler: vueTemplateCompiler,
        transformAssetUrls: true,
        transformAssetUrlsOptions: devServer
            ? {
                base: path_1.default.posix.dirname(path_1.default.relative(root, filename)),
            }
            : {},
        isProduction,
        isFunctional: !!block.attrs.functional,
        optimizeSSR: false,
        prettify: false,
        ...vueTemplateOptions,
    });
    if (tips) {
        tips.forEach(console.warn);
    }
    // todo
    if (errors) {
        // 	errors.forEach((e) => pluginContext.error(e))
    }
    if (devServer) {
        return code + `\nexport { render, staticRenderFns }`;
    }
    // rewrite require calls to import on build
    return transformRequireToImport(code) + `\nexport { render, staticRenderFns }`;
}
exports.compileSFCTemplate = compileSFCTemplate;
function transformRequireToImport(code) {
    const imports = {};
    let strImports = '';
    code = code.replace(/require\(("(?:[^"\\]|\\.)+"|'(?:[^'\\]|\\.)+')\)/g, (_, name) => {
        if (!(name in imports)) {
            imports[name] = `__$_require_${name
                .replace(/[^a-z0-9]/g, '_')
                .replace(/_{2,}/g, '_')
                .replace(/^_|_$/g, '')}__`;
            strImports += 'import ' + imports[name] + ' from ' + name + '\n';
        }
        return imports[name];
    });
    return strImports + code;
}
exports.transformRequireToImport = transformRequireToImport;
//# sourceMappingURL=template.js.map